<component>
  <actions>
    <action id="IncrementalSearch" class="com.intellij.codeInsight.navigation.actions.IncrementalSearchAction"/>
    <action id="AddToFavoritesPopup" class="com.intellij.ide.favoritesTreeView.actions.AddToFavoritesPopupAction"/>
    <group id="AddToFavorites" class="com.intellij.ide.favoritesTreeView.actions.AddToFavoritesActionGroup" popup="true"/>
    <group id="AddAllToFavorites" class="com.intellij.ide.favoritesTreeView.actions.AddAllToFavoritesActionGroup" popup="true"/>
    <action id="AddNewFavoritesList" class="com.intellij.ide.favoritesTreeView.actions.AddNewFavoritesListAction"/>
    <group id="SendToFavoritesGroup" class="com.intellij.ide.favoritesTreeView.actions.SendToFavoritesGroup" popup="true"/>
    <group id="MoveModuleToGroup" class="com.intellij.ide.projectView.impl.MoveModuleToGroupTopLevel" popup="true"/>

    <action id="RunConfiguration" class="com.intellij.execution.actions.RunConfigurationAction"/>
    <action id="ChooseRunConfiguration" class="com.intellij.execution.actions.ChooseRunConfigurationAction" text="Run..." icon="/general/toolWindowRun.png"/>
    <action id="ChooseDebugConfiguration" class="com.intellij.execution.actions.ChooseDebugConfigurationAction" text="Debug..." icon="/general/debug.png"/>

    <group id="RunContextGroup" popup="false">
      <action id="CreateRunConfiguration" class="com.intellij.execution.actions.CreateAction"/>
    </group>
    <group id="RunContextPopupGroup" popup="false">
      <reference ref="RunContextGroup"/>
    </group>

    <group id="LangCodeInsightActions">
      <action id="EditorSelectWord" class="com.intellij.openapi.editor.actions.SelectWordAtCaretAction"/>
      <action id="EditorUnSelectWord" class="com.intellij.openapi.editor.actions.UnselectWordAtCaretAction"/>

      <add-to-group group-id="EditorActions" anchor="last"/>
    </group>

    <group id="GenerateGroup">
      <action id="OverrideMethods" class="com.intellij.codeInsight.generation.actions.OverrideMethodsAction"/>
      <action id="ImplementMethods" class="com.intellij.codeInsight.generation.actions.ImplementMethodsAction"/>
    </group>

    <action id="ShowIntentionActions" class="com.intellij.codeInsight.intention.actions.ShowIntentionActionsAction"/>

    <action id="TogglePopupHints" class="com.intellij.ide.actions.TogglePopupHintsAction"/>
    <action id="FindModal" class="com.intellij.openapi.editor.actions.FindAction" icon="/actions/menu-find.png"/>

    <action id="CodeInspection.OnEditor" class="com.intellij.codeInspection.actions.CodeInspectionOnEditorAction"/>

    <action id="ActivateNavBar" class="com.intellij.ide.navigationToolbar.ActivateNavigationBarAction" popup="true"/>

    <group id="CodeInsightEditorActions">
      <reference ref="LookupActions"/>
      <action id="EmacsStyleIndent" class="com.intellij.codeInsight.editorActions.EmacsStyleIndentAction"/>
      <action id="EditorCodeBlockStart" class="com.intellij.codeInsight.editorActions.CodeBlockStartAction"/>
      <action id="EditorCodeBlockEnd" class="com.intellij.codeInsight.editorActions.CodeBlockEndAction"/>
      <action id="EditorCodeBlockStartWithSelection" class="com.intellij.codeInsight.editorActions.CodeBlockStartWithSelectionAction"/>
      <action id="EditorCodeBlockEndWithSelection" class="com.intellij.codeInsight.editorActions.CodeBlockEndWithSelectionAction"/>
      <action id="EditorCompleteStatement" class="com.intellij.codeInsight.editorActions.smartEnter.SmartEnterAction"/>

      <add-to-group group-id="EditorActions" anchor="last"/>
    </group>

    <!-- File -->

    <action id="ReloadFromDisk" class="com.intellij.ide.actions.ReloadFromDiskAction">
      <add-to-group group-id="FileMenu" anchor="after" relative-to-action="Synchronize"/>
    </action>


    <group id="PrintExportGroup">
      <separator/>
      <action id="ExportToHTML" class="com.intellij.codeEditor.printing.ExportToHTMLAction"/>
      <action id="Print" class="com.intellij.codeEditor.printing.PrintAction"/>

      <add-to-group group-id="FileMenu" anchor="after" relative-to-action="InvalidateCaches"/>
    </group>

    <action id="ChangeTemplateDataLanguage" class="com.intellij.psi.templateLanguages.ChangeTemplateDataLanguageAction">
      <add-to-group group-id="FileMenu" anchor="after" relative-to-action="ChangeFileEncodingGroup"/>
    </action>

    <!-- Edit -->
    <action id="CopyReference" class="com.intellij.ide.actions.CopyReferenceAction">
      <add-to-group group-id="CutCopyPasteGroup" anchor="after" relative-to-action="CopyPaths"/>
      <add-to-group group-id="EditorPopupMenu" anchor="after" relative-to-action="$Copy"/>
    </action>

    <group id="EditSelectWordGroup">
      <reference ref="EditorSelectWord"/>
      <reference ref="EditorUnSelectWord"/>

      <add-to-group group-id="EditSelectGroup" anchor="last"/>
    </group>

    <group id="EditBookmarksGroup">
      <action id="ToggleBookmark" class="com.intellij.ide.bookmarks.actions.ToggleBookmarkAction"/>
      <action id="ToggleBookmarkWithMnemonic" class="com.intellij.ide.bookmarks.actions.ToggleBookmarkWithMnemonicAction"/>
      <action id="ShowBookmarks" class="com.intellij.ide.bookmarks.actions.BookmarksAction"/>
      <separator/>

      <add-to-group group-id="EditMenu" anchor="after" relative-to-action="EditCreateDeleteGroup"/>
    </group>

    <!-- Search -->
    <group id="SearchMenu" popup="true">
      <action id="Find" class="com.intellij.openapi.editor.actions.IncrementalFindAction" icon="/actions/menu-find.png"/>
      <action id="Replace" class="com.intellij.openapi.editor.actions.ReplaceAction" icon="/actions/menu-replace.png"/>
      <action id="FindNext" class="com.intellij.ide.actions.SearchAgainAction"/>
      <action id="FindPrevious" class="com.intellij.ide.actions.SearchBackAction"/>
      <action id="FindWordAtCaret" class="com.intellij.openapi.editor.actions.FindWordAtCaretAction"/>
      <separator/>
      <action id="FindUsages" class="com.intellij.find.actions.FindUsagesAction"/>
      <action id="ShowUsages" class="com.intellij.find.actions.ShowUsagesAction"/>
      <action id="FindUsagesInFile" class="com.intellij.find.actions.FindUsagesInFileAction"/>
      <action id="HighlightUsagesInFile" class="com.intellij.codeInsight.highlighting.actions.HighlightUsagesAction"/>
      <group id="ShowRecentFindUsagesGroup" class="com.intellij.find.impl.ShowRecentFindUsagesGroup" popup="true"/>
      <separator/>
      <action id="FindInPath" class="com.intellij.find.actions.FindInPathAction"/>
      <action id="ReplaceInPath" class="com.intellij.find.actions.ReplaceInPathAction"/>
      <separator/>
      <action id="GotoAction" class="com.intellij.ide.actions.GotoActionAction"/>

      <add-to-group group-id="MainMenu" anchor="after" relative-to-action="EditMenu"/>
    </group>

    <!-- View -->
    <action id="ViewNavigationBar" class="com.intellij.ide.actions.ViewNavigationBarAction">
      <add-to-group group-id="ViewMenu" relative-to-action="ViewStatusBar" anchor="after"/>
    </action>

    <action id="ViewImportPopups" class="com.intellij.openapi.editor.actions.ToggleShowImportPopupsAction">
      <add-to-group group-id="ViewMenu" relative-to-action="EditorToggleShowLineNumbers" anchor="after"/>
    </action>

    <action id="ShowUsagesSettings" class="com.intellij.find.actions.ShowUsagesAction$ShowSettings"/>

    <group id="CodeEditorBaseGroup">
      <separator/>
      <group id="CodeEditorViewGroup" class="com.intellij.ide.actions.CodeEditorActionGroup">
        <action id="FileStructurePopup" class="com.intellij.ide.actions.ViewStructureAction"/>
        <action id="QuickJavaDoc" class="com.intellij.codeInsight.documentation.actions.ShowJavaDocInfoAction"/>
        <action id="ExternalJavaDoc" class="com.intellij.ide.actions.ExternalJavaDocAction"/>
        <action id="SelectIn" class="com.intellij.ide.actions.SelectInAction"/>
        <action id="ParameterInfo" class="com.intellij.codeInsight.hint.actions.ShowParameterInfoAction"/>
        <action id="ShowErrorDescription" class="com.intellij.codeInsight.daemon.impl.actions.ShowErrorDescriptionAction"/>
        <action id="ShowFilePath" class="com.intellij.ide.actions.ShowFilePathAction"/>
        <action id="PopupHector" class="com.intellij.codeInsight.daemon.impl.PopupHectorAction"/>
      </group>
      <separator/>

      <group id="ProjectViewGroup" class="com.intellij.ide.projectView.actions.ProjectViewActionGroup">
        <action id="ProjectViewChangeView" class="com.intellij.ide.projectView.actions.ChangeProjectViewAction"/>
      </group>
      <separator/>
      <reference ref="AddToFavorites"/>
      <separator/>

      <add-to-group group-id="ViewMenu" relative-to-action="QuickChangeScheme" anchor="after"/>
    </group>

    <group id="FoldingGroup" class="com.intellij.codeInsight.folding.impl.actions.FoldingActionGroup" popup="true">
      <action id="ExpandRegion" class="com.intellij.codeInsight.folding.impl.actions.ExpandRegionAction"/>
      <action id="CollapseRegion" class="com.intellij.codeInsight.folding.impl.actions.CollapseRegionAction"/>
      <separator/>
      <action id="ExpandAllRegions" class="com.intellij.codeInsight.folding.impl.actions.ExpandAllRegionsAction"/>
      <action id="CollapseAllRegions" class="com.intellij.codeInsight.folding.impl.actions.CollapseAllRegionsAction"/>
      <separator/>
      <group id="LanguageSpecificFoldingGroup"/>
      <separator/>
      <action id="CollapseSelection" class="com.intellij.codeInsight.folding.impl.actions.CollapseSelectionAction"/>

      <add-to-group group-id="ViewMenu" anchor="last"/>
    </group>

    <!-- TODO: correct action location -->
    <action id="QuickImplementations" class="com.intellij.codeInsight.hint.actions.ShowImplementationsAction">
      <add-to-group group-id="ViewMenu" relative-to-action="ToggleFullScreenMode" anchor="after"/>
    </action>

    <action id="RecentChanges" class="com.intellij.history.integration.ui.actions.RecentChangesAction">
      <keyboard-shortcut first-keystroke="alt shift C" keymap="$default"/>
      <add-to-group group-id="ViewRecentActions" anchor="last"/>
    </action>

    <group id="HierarchyGroup">
      <separator/>
      <action id="TypeHierarchy" class="com.intellij.ide.hierarchy.actions.BrowseTypeHierarchyAction"/>
      <action id="MethodHierarchy" class="com.intellij.ide.hierarchy.actions.BrowseMethodHierarchyAction"/>
      <action id="CallHierarchy" class="com.intellij.ide.hierarchy.actions.BrowseCallHierarchyAction"/>
      <separator/>

      <add-to-group group-id="ViewMenu" anchor="last"/>
    </group>

    <!-- Go To -->
    <group id="GoToTargetEx">
      <action id="GotoClass" class="com.intellij.ide.actions.GotoClassAction"/>
      <action id="GotoFile" class="com.intellij.ide.actions.GotoFileAction"/>
      <action id="GotoSymbol" class="com.intellij.ide.actions.GotoSymbolAction"/>

      <add-to-group group-id="GoToMenu" anchor="first"/>
    </group>

    <group id="GoToErrorGroup">
      <separator/>
      <action id="GotoNextError" class="com.intellij.codeInsight.daemon.impl.actions.GotoNextErrorAction"/>
      <action id="GotoPreviousError" class="com.intellij.codeInsight.daemon.impl.actions.GotoPreviousErrorAction"/>
      <separator/>

      <action id="GotoNextBookmark" class="com.intellij.ide.bookmarks.actions.NextBookmarkAction"/>
      <action id="GotoPreviousBookmark" class="com.intellij.ide.bookmarks.actions.PreviousBookmarkAction"/>
      <add-to-group group-id="GoToMenu" anchor="before" relative-to-action="Back"/>
    </group>

    <group id="GoToMenuEx">
      <separator/>
      <action id="MethodDown" class="com.intellij.codeInsight.navigation.actions.MethodDownAction"/>
      <action id="MethodUp" class="com.intellij.codeInsight.navigation.actions.MethodUpAction"/>
      <separator/>
      <add-to-group group-id="GoToMenu" anchor="after" relative-to-action="GoToPreviousError"/>
    </group>

    <group id="GoToCodeGroup">
      <action id="ShowNavBar" class="com.intellij.ide.navigationToolbar.PopupToolbarAction"/>
      <action id="GotoDeclaration" class="com.intellij.codeInsight.navigation.actions.GotoDeclarationAction"/>
      <action id="GotoImplementation" class="com.intellij.codeInsight.navigation.actions.GotoImplementationAction"/>
      <action id="GotoTypeDeclaration" class="com.intellij.codeInsight.navigation.actions.GotoTypeDeclarationAction"/>
      <action id="GotoSuperMethod" class="com.intellij.codeInsight.navigation.actions.GotoSuperAction"/>
      <action id="GotoTest" class="com.intellij.testIntegration.GotoTestOrCodeAction"/>
      <separator/>

      <add-to-group group-id="GoToMenu" anchor="before" relative-to-action="GoToErrorGroup"/>
    </group>

    <!-- Code -->
    <group id="CodeMenu" popup="true">
      <reference ref="OverrideMethods"/>
      <reference ref="ImplementMethods"/>
      <action id="Generate" class="com.intellij.codeInsight.generation.actions.GenerateAction"/>
      <separator/>
      <action id="SurroundWith" class="com.intellij.codeInsight.generation.actions.SurroundWithAction"/>
      <action id="Unwrap" class="com.intellij.codeInsight.unwrap.UnwrapAction"/>
      <separator/>

      <group id="CodeCompletionGroup" class="com.intellij.codeInsight.completion.actions.CodeCompletionGroup" popup="true">
        <action id="CodeCompletion" class="com.intellij.codeInsight.completion.actions.CodeCompletionAction"/>
        <action id="SmartTypeCompletion" class="com.intellij.codeInsight.completion.actions.SmartCodeCompletionAction"/>
        <action id="ClassNameCompletion" class="com.intellij.codeInsight.completion.actions.ClassNameCompletionAction"/>
        <separator/>
        <action id="HippieCompletion" class="com.intellij.codeInsight.completion.actions.HippieCompletionAction"/>
        <action id="HippieBackwardCompletion" class="com.intellij.codeInsight.completion.actions.HippieBackwardCompletionAction"/>
      </group>

      <separator/>

      <action id="InsertLiveTemplate" class="com.intellij.codeInsight.template.impl.actions.ListTemplatesAction"/>
      <action id="SurroundWithLiveTemplate" class="com.intellij.codeInsight.template.impl.actions.SurroundWithTemplateAction"/>
      <separator/>

      <group id="CommentGroup">
        <action id="CommentByLineComment" class="com.intellij.codeInsight.generation.actions.CommentByLineCommentAction"/>
        <action id="CommentByBlockComment" class="com.intellij.codeInsight.generation.actions.CommentByBlockCommentAction"/>
      </group>

      <group id="CodeFormatGroup">
        <action id="ReformatCode" class="com.intellij.codeInsight.actions.ReformatCodeAction"/>
        <action id="AutoIndentLines" class="com.intellij.codeInsight.generation.actions.AutoIndentLinesAction"/>
        <action id="OptimizeImports" class="com.intellij.codeInsight.actions.OptimizeImportsAction"/>
      </group>

      <separator/>
      <action id="MoveStatementDown" class="com.intellij.codeInsight.editorActions.moveUpDown.MoveStatementDownAction"/>
      <action id="MoveStatementUp" class="com.intellij.codeInsight.editorActions.moveUpDown.MoveStatementUpAction"/>
      <add-to-group group-id="MainMenu" anchor="after" relative-to-action="GoToMenu"/>
    </group>

    <!-- Refactor -->
    <group id="RefactoringMenu" popup="true">
      <action id="RenameElement" class="com.intellij.refactoring.actions.RenameElementAction"/>
      <separator/>
      <action id="Move" class="com.intellij.refactoring.actions.MoveAction"/>
      <action id="CopyElement" class="com.intellij.ide.actions.CopyElementAction"/>
      <action id="CloneElement" class="com.intellij.ide.actions.CloneElementAction"/>
      <action id="SafeDelete" class="com.intellij.refactoring.actions.SafeDeleteAction"/>
      <separator/>
      <action id="ExtractMethod" class="com.intellij.refactoring.actions.ExtractMethodAction"/>
      <action id="IntroduceVariable" class="com.intellij.refactoring.actions.IntroduceVariableAction"/>
      <action id="IntroduceConstant" class="com.intellij.refactoring.actions.IntroduceConstantAction"/>
      <action id="IntroduceField" class="com.intellij.refactoring.actions.IntroduceFieldAction"/>
      <action id="IntroduceParameter" class="com.intellij.refactoring.actions.IntroduceParameterAction"/>
      <action id="Inline" class="com.intellij.refactoring.actions.InlineAction"/>
      <separator/>
      <action id="MembersPullUp" class="com.intellij.refactoring.actions.PullUpAction"/>
      <action id="MemberPushDown" class="com.intellij.refactoring.actions.PushDownAction"/>
      <separator/>
      <action id="ExtractInclude" class="com.intellij.refactoring.actions.ExtractIncludeAction"/>
      <action id="ExtractSuperclass" class="com.intellij.refactoring.actions.ExtractSuperclassAction"/>
      <add-to-group group-id="MainMenu" anchor="after" relative-to-action="CodeMenu"/>
    </group>

    <!-- Run -->
    <group id="RunMenu" popup="true">
      <group id="RunnerActions"/>
      <reference ref="ChooseRunConfiguration"/>
      <reference ref="ChooseDebugConfiguration"/>
      <action id="editRunConfigurations" class="com.intellij.execution.actions.EditRunConfigurationsAction"/>
      <action id="Stop" class="com.intellij.execution.actions.StopAction" icon="/actions/suspend.png"/>

      <add-to-group group-id="MainMenu" anchor="after" relative-to-action="RefactoringMenu"/>
    </group>


    <!-- Tools -->
    <group id="ToolsBasicGroup">
      <action id="SaveAsTemplate" class="com.intellij.codeInsight.template.actions.SaveAsTemplateAction"/>
      <action id="SaveFileAsTemplate" class="com.intellij.ide.actions.SaveFileAsTemplateAction"/>
      <separator/>

      <add-to-group group-id="ToolsMenu" anchor="first"/>
    </group>

    <group id="ExternalToolsGroup" class="com.intellij.tools.ExternalToolsGroup">
      <add-to-group group-id="ToolsMenu" anchor="last"/>
    </group>

    <group id="NewGroup" popup="true">
      <action id="NewFile" class="com.intellij.ide.actions.CreateFileAction"/>
      <action id="NewDir" class="com.intellij.ide.actions.CreateDirectoryOrPackageAction"/>
      <separator/>
      <action id="NewFromTemplate" class="com.intellij.ide.fileTemplates.actions.CreateFromTemplateGroup"/>
    </group>

    <group id="WeighingNewGroup" class="com.intellij.ide.actions.WeighingNewActionGroup"/>

    <!-- Toolbar -->
    <!--
    <group id="ToolbarNewElement">
      <action id="NewElementToolbarAction" class="com.intellij.ide.actions.NewElementToolbarAction" icon="/general/plus.png"/>
      <add-to-group group-id="MainToolBar" anchor="first"/>
    </group>
    -->

    <group id="ToolbarFindGroup">
      <separator/>

      <reference ref="Find"/>
      <reference ref="Replace"/>

      <add-to-group group-id="MainToolBar" relative-to-action="$Paste" anchor="after"/>
    </group>

    <group id="ToolbarRunGroup">
      <separator/>
      <reference ref="RunConfiguration"/>
      <reference ref="RunnerActions"/>

      <add-to-group group-id="MainToolBar" relative-to-action="Forward" anchor="after"/>
    </group>

    <group id="Bookmarks">
      <reference ref="ToggleBookmark"/>
      <reference ref="ShowBookmarks"/>
      <reference ref="GotoNextBookmark"/>
      <reference ref="GotoPreviousBookmark"/>

      <action id="GotoBookmark0" class="com.intellij.ide.bookmarks.actions.GotoBookmark0Action"/>
      <action id="GotoBookmark1" class="com.intellij.ide.bookmarks.actions.GotoBookmark1Action"/>
      <action id="GotoBookmark2" class="com.intellij.ide.bookmarks.actions.GotoBookmark2Action"/>
      <action id="GotoBookmark3" class="com.intellij.ide.bookmarks.actions.GotoBookmark3Action"/>
      <action id="GotoBookmark4" class="com.intellij.ide.bookmarks.actions.GotoBookmark4Action"/>
      <action id="GotoBookmark5" class="com.intellij.ide.bookmarks.actions.GotoBookmark5Action"/>
      <action id="GotoBookmark6" class="com.intellij.ide.bookmarks.actions.GotoBookmark6Action"/>
      <action id="GotoBookmark7" class="com.intellij.ide.bookmarks.actions.GotoBookmark7Action"/>
      <action id="GotoBookmark8" class="com.intellij.ide.bookmarks.actions.GotoBookmark8Action"/>
      <action id="GotoBookmark9" class="com.intellij.ide.bookmarks.actions.GotoBookmark9Action"/>

      <action id="ToggleBookmark0" class="com.intellij.ide.bookmarks.actions.ToggleBookmark0Action"/>
      <action id="ToggleBookmark1" class="com.intellij.ide.bookmarks.actions.ToggleBookmark1Action"/>
      <action id="ToggleBookmark2" class="com.intellij.ide.bookmarks.actions.ToggleBookmark2Action"/>
      <action id="ToggleBookmark3" class="com.intellij.ide.bookmarks.actions.ToggleBookmark3Action"/>
      <action id="ToggleBookmark4" class="com.intellij.ide.bookmarks.actions.ToggleBookmark4Action"/>
      <action id="ToggleBookmark5" class="com.intellij.ide.bookmarks.actions.ToggleBookmark5Action"/>
      <action id="ToggleBookmark6" class="com.intellij.ide.bookmarks.actions.ToggleBookmark6Action"/>
      <action id="ToggleBookmark7" class="com.intellij.ide.bookmarks.actions.ToggleBookmark7Action"/>
      <action id="ToggleBookmark8" class="com.intellij.ide.bookmarks.actions.ToggleBookmark8Action"/>
      <action id="ToggleBookmark9" class="com.intellij.ide.bookmarks.actions.ToggleBookmark9Action"/>

    </group>

    <group id="ProjectViewPopupMenuRefactoringGroup">
      <reference ref="RefactoringMenu"/>
    </group>

    <group id="ProjectViewPopupMenuModifyGroup">
      <reference ref="$Delete"/>
    </group>

    <group id="ProjectViewPopupMenuRunGroup">
      <reference ref="RunContextPopupGroup"/>
    </group>

    <group id="ProjectViewPopupMenuSettingsGroup">
      <reference ref="MoveModuleToGroup"/>
    </group>

    <group id="ProjectViewPopupMenu">
      <reference ref="WeighingNewGroup"/>
      <action id="AssociateWithFileType" class="com.intellij.ide.actions.AssociateFileType"/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <reference ref="EditSource"/>
      <reference ref="ChangesView.ApplyPatch"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="FindInPath"/>
      <reference ref="ReplaceInPath"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRefactoringGroup"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuModifyGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRunGroup"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <action id="SynchronizeCurrentFile" class="com.intellij.ide.actions.SynchronizeCurrentFileAction" icon="/actions/sync.png"/>
      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuSettingsGroup"/>
    </group>

    <group id="NavbarPopupMenu">
      <reference ref="WeighingNewGroup"/>
      <reference ref="AssociateWithFileType"/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <reference ref="EditSource"/>
      <reference ref="ChangesView.ApplyPatch"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="FindInPath"/>
      <reference ref="ReplaceInPath"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRefactoringGroup"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuModifyGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRunGroup"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <reference ref="SynchronizeCurrentFile"/>
      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuSettingsGroup"/>
    </group>

    <group id="FavoritesViewPopupMenu">
      <reference ref="NewGroup"/>
      <reference ref="AssociateWithFileType"/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <reference ref="EditSource"/>
      <reference ref="ChangesView.ApplyPatch"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="FindInPath"/>
      <reference ref="ReplaceInPath"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRefactoringGroup"/>
      <separator/>
      <action id="RenameFavoritesList" class="com.intellij.ide.favoritesTreeView.actions.RenameFavoritesListAction"/>
      <action id="RemoveFromFavorites" class="com.intellij.ide.favoritesTreeView.actions.DeleteFromFavoritesAction"/>
      <action id="RemoveFavoritesList" class="com.intellij.ide.favoritesTreeView.actions.DeleteFavoritesListAction"/>
      <action id="RemoveAllFavoritesListsButThis" class="com.intellij.ide.favoritesTreeView.actions.DeleteAllFavoritesListsButThisAction"/>
      <reference ref="SendToFavoritesGroup"/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuModifyGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuRunGroup"/>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <reference ref="SynchronizeCurrentFile"/>
      <reference ref="CompareTwoFiles"/>
      <reference ref="CompareFileWithEditor"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>
      <separator/>
      <reference ref="ProjectViewPopupMenuSettingsGroup"/>
    </group>

    <group id="ScopeViewPopupMenu">
      <reference ref="ProjectViewPopupMenu"/>
      <separator/>
      <action id="ScopeView.EditScopes" class="com.intellij.ide.scopeView.EditScopesAction"/>
    </group>

    <group id="StructureViewPopupMenu">
      <reference ref="EditSource"/>
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="RefactoringMenu"/>
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <separator/>
      <reference ref="CutCopyPasteGroup"/>
      <separator/>
      <reference ref="RunContextPopupGroup"/>
      <reference ref="VersionControlsGroup"/>
      <separator/>
      <reference ref="CompareTwoFiles"/>
    </group>

    <group id="EditorPopupMenu1">
      <separator/>
      <reference ref="FindUsages"/>
      <reference ref="RefactoringMenu"/>
      <separator/>
      <reference ref="FoldingGroup"/>
      <separator/>

      <add-to-group group-id="EditorPopupMenu" relative-to-action="MoveToChangeList" anchor="before"/>
    </group>

    <group id="EditorLangPopupMenu">
      <separator/>
      <group id="EditorPopupMenu.GoTo" popup="true">
        <reference ref="ShowNavBar"/>
        <reference ref="GotoDeclaration"/>
        <reference ref="GotoImplementation"/>
        <reference ref="GotoTypeDeclaration"/>
        <reference ref="GotoSuperMethod"/>
        <reference ref="GotoTest"/>
      </group>
      <reference ref="Generate"/>
      <separator/>

      <group id="EditorPopupMenu.Run">
        <reference ref="RunContextPopupGroup"/>
      </group>
      <separator/>
      <reference ref="VersionControlsGroup"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>

      <add-to-group group-id="EditorPopupMenu" relative-to-action="CompareClipboardWithSelection" anchor="before"/>
    </group>

    <group id="EditorTabPopupMenuEx">
      <separator/>
      <reference ref="AddToFavorites"/>
      <reference ref="AddAllToFavorites"/>
      <separator/>
      <reference ref="MoveToChangeList"/>
      <separator/>
      <reference ref="RunContextPopupGroup"/>
      <reference ref="VersionControlsGroup"/>
      <separator/>
      <reference ref="ExternalToolsGroup"/>

      <add-to-group group-id="EditorTabPopupMenu" anchor="last"/>
    </group>

    <reference ref="ChangeTemplateDataLanguage">
      <add-to-group group-id="EditorPopupMenu" anchor="after" relative-to-action="ChangeFileEncodingGroup"/>
    </reference>

    <group id="UsageView.Popup">
      <reference ref="EditSource"/>
      <action id="UsageView.Include" class="com.intellij.usages.actions.IncludeUsageAction"/>
      <action id="UsageView.Exclude" class="com.intellij.usages.actions.ExcludeUsageAction"/>
      <separator/>
      <action id="UsageView.ShowRecentFindUsages" class="com.intellij.find.impl.ShowRecentFindUsagesAction" icon="/actions/back.png"/>
    </group>

    <action id="NewElementSamePlace" class="com.intellij.ide.actions.NewElementSamePlaceAction"/>

    <action id="ChangeCodeStyleScheme" class="com.intellij.ide.actions.QuickChangeCodeStyleSchemeAction">
      <add-to-group group-id="ChangeScheme" anchor="after" relative-to-action="ChangeColorScheme"/>
    </action>

    <action id="TypeHierarchyBase.BaseOnThisType" text="Base on This Type" class="com.intellij.ide.hierarchy.TypeHierarchyBrowserBase$BaseOnThisTypeAction"/>
    <action id="TypeHierarchy.Class" class="com.intellij.ide.hierarchy.ViewClassHierarchyAction"/>
    <action id="TypeHierarchy.Subtypes" class="com.intellij.ide.hierarchy.ViewSubtypesHierarchyAction"/>
    <action id="TypeHierarchy.Supertypes" class="com.intellij.ide.hierarchy.ViewSupertypesHierarchyAction"/>

    <group id="DebugMainMenu">
      <separator/>
      <action id="StepOver" class="com.intellij.xdebugger.impl.actions.StepOverAction" icon="/actions/traceOver.png"/>
      <action id="StepInto" class="com.intellij.xdebugger.impl.actions.StepIntoAction" icon="/actions/traceInto.png"/>
      <action id="SmartStepInto" class="com.intellij.xdebugger.impl.actions.SmartStepIntoAction" icon="/actions/traceInto.png"/>
      <action id="StepOut" class="com.intellij.xdebugger.impl.actions.StepOutAction" icon="/actions/stepOut.png"/>
      <action id="ForceStepOver" class="com.intellij.xdebugger.impl.actions.ForceStepOverAction" icon="/actions/traceOver.png"/>
      <action id="ForceStepInto" class="com.intellij.xdebugger.impl.actions.ForceStepIntoAction" icon="/actions/forceStepInto.png"/>
      <action id="RunToCursor" class="com.intellij.xdebugger.impl.actions.RunToCursorAction" icon="/actions/runToCursor.png"/>
      <action id="ForceRunToCursor" class="com.intellij.xdebugger.impl.actions.ForceRunToCursorAction"/>
      <action id="Pause" class="com.intellij.xdebugger.impl.actions.PauseAction" icon="/actions/pause.png"/>
      <action id="Resume" class="com.intellij.xdebugger.impl.actions.ResumeAction" icon="/actions/resume.png"/>
      <separator/>
      <action id="EvaluateExpression" class="com.intellij.xdebugger.impl.actions.EvaluateAction" icon="/debugger/evaluateExpression.png"/>
      <action id="QuickEvaluateExpression" class="com.intellij.xdebugger.impl.actions.QuickEvaluateAction"/>
      <action id="ShowExecutionPoint" class="com.intellij.xdebugger.impl.actions.ShowExecutionPointAction"
              icon="/debugger/showCurrentFrame.png"/>
      <separator/>
      <action id="ToggleLineBreakpoint" class="com.intellij.xdebugger.impl.actions.ToggleLineBreakpointAction"/>
      <action id="ViewBreakpoints" class="com.intellij.xdebugger.impl.actions.ViewBreakpointsAction" icon="/debugger/viewBreakpoints.png"/>
      <separator/>

      <add-to-group group-id="RunMenu" anchor="last"/>
    </group>

    <group id="XDebugger.Actions">
      <action id="XDebugger.SetValue" class="com.intellij.xdebugger.impl.ui.tree.actions.XSetValueAction"/>
      <action id="XDebugger.CopyValue" class="com.intellij.xdebugger.impl.ui.tree.actions.XCopyValueAction"/>
      <action id="XDebugger.Inspect" class="com.intellij.xdebugger.impl.ui.tree.actions.XInspectAction"/>
      <action id="XDebugger.JumpToSource" class="com.intellij.xdebugger.impl.ui.tree.actions.XJumpToSourceAction"/>
      <action id="XDebugger.AddToWatches" class="com.intellij.xdebugger.impl.ui.tree.actions.XAddToWatchesAction"/>
      <action id="XDebugger.NewWatch" class="com.intellij.xdebugger.impl.frame.actions.XNewWatchAction" icon="/debugger/newWatch.png"/>
      <action id="XDebugger.EditWatch" class="com.intellij.xdebugger.impl.frame.actions.XEditWatchAction"/>
      <action id="XDebugger.RemoveWatch" class="com.intellij.xdebugger.impl.frame.actions.XRemoveWatchAction" icon="/actions/delete.png"/>
      <action id="XDebugger.MuteBreakpoints" class="com.intellij.xdebugger.impl.actions.MuteBreakpointAction"
              icon="/debugger/muteBreakpoints.png"/>
      <action id="XDebugger.AutoTooltip" class="com.intellij.xdebugger.impl.actions.ValueTooltipAutoShowAction"/>
    </group>

    <group id="XDebugger.Evaluation.Dialog.Tree.Popup">
      <reference ref="XDebugger.Inspect"/>
      <reference ref="XDebugger.SetValue"/>
      <reference ref="XDebugger.CopyValue"/>
    </group>

    <group id="XDebugger.Variables.Tree.Popup">
      <reference ref="XDebugger.Inspect"/>
      <reference ref="XDebugger.SetValue"/>
      <reference ref="XDebugger.CopyValue"/>
      <reference ref="XDebugger.JumpToSource"/>
      <reference ref="XDebugger.AddToWatches"/>
    </group>

    <group id="XDebugger.Watches.Tree.Popup">
      <reference ref="XDebugger.EditWatch"/>
      <reference ref="XDebugger.Inspect"/>
      <reference ref="XDebugger.SetValue"/>
      <reference ref="XDebugger.CopyValue"/>
    </group>

    <group id="XDebugger.Watches.Tree.Toolbar">
      <reference ref="XDebugger.NewWatch"/>
      <reference ref="XDebugger.RemoveWatch"/>
    </group>

    <group id="XDebugger.Inspect.Tree.Popup">
      <reference ref="XDebugger.Inspect"/>
      <reference ref="XDebugger.CopyValue"/>
    </group>

    <group id="RunnerLayoutActions">
      <group id="Runner.Layout" icon="/debugger/restoreLayout.png" popup="true">
        <action id="Runner.RestoreLayout" class="com.intellij.execution.ui.layout.actions.RestoreLayoutAction"/>
        <action id="Runner.ToggleToolbarLayout" class="com.intellij.execution.ui.layout.actions.ToggleToolbarLayoutAction"/>
      </group>


      <group id="Runner.View.Popup">
        <action id="Runner.MoveViewToGrid" class="com.intellij.execution.ui.layout.actions.MoveToGridAction" icon="/debugger/toGrid.png"/>
        <action id="Runner.MoveViewToTab" class="com.intellij.execution.ui.layout.actions.MoveToTabAction" icon="/debugger/toTab.png"/>
        <action id="Runner.DetachCell" class="com.intellij.execution.ui.layout.actions.DetachCellAction" icon="/debugger/detach.png"/>
        <action id="Runner.AttachCell" class="com.intellij.execution.ui.layout.actions.AttachCellAction" icon="/debugger/attach.png"/>
        <separator/>
        <action id="Runner.MinimizeView" class="com.intellij.execution.ui.layout.actions.MinimizeViewAction" icon="/actions/minimize.png"/>
        <separator/>
        <action id="Runner.CloseView" class="com.intellij.execution.ui.layout.actions.CloseViewAction" icon="/actions/cross.png"/>
        <separator/>
        <group id="Runner.Focus">
          <action id="Runner.FocusOnStartup" class="com.intellij.execution.ui.actions.FocusOnStartAction"/>
        </group>
      </group>


      <group id="Runner.View.Toolbar">
        <reference ref="Runner.MoveViewToGrid"/>
        <reference ref="Runner.MoveViewToTab"/>
        <reference ref="Runner.DetachCell"/>
        <reference ref="Runner.AttachCell"/>
        <reference ref="Runner.MinimizeView"/>
        <reference ref="Runner.CloseView"/>
      </group>
    </group>

    <group id="LocalHistory" class="com.intellij.history.integration.ui.actions.LocalHistoryGroup" popup="true">
      <action id="LocalHistory.ShowHistory" class="com.intellij.history.integration.ui.actions.ShowHistoryAction"/>
      <action id="LocalHistory.ShowSelectionHistory" class="com.intellij.history.integration.ui.actions.ShowSelectionHistoryAction"/>
      <action id="LocalHistory.PutLabel" class="com.intellij.history.integration.ui.actions.PutLabelAction"/>

      <add-to-group group-id="VersionControlsGroup" anchor="first"/>
      <add-to-group group-id="VcsGroups" anchor="first"/>
    </group>

    <group id="TestTreePopupMenu">
      <reference ref="RunContextGroup"/>
      <separator/>
      <reference ref="EditSource"/>
      <reference ref="ViewSource"/>
    </group>

    <!-- SM Test Runner Actions -->
    <group id="SMTestRunnerTestsTree">
      <separator/>
      <action id="com.intellij.execution.testframework.sm.runner.ui.statistics.ShowStatisticsAction"
              class="com.intellij.execution.testframework.sm.runner.ui.statistics.ShowStatisticsAction"
              text="Show Statistics"/>
      <add-to-group group-id="TestTreePopupMenu" anchor="last"/>
    </group>
    <group id="SMTestRunnerStatistics">
      <separator/>
      <action id="com.intellij.execution.testframework.sm.runner.ui.statistics.ShowTestProxy"
              class="com.intellij.execution.testframework.sm.runner.ui.statistics.ShowTestProxy"
              text="Navigate to Test"/>
      <add-to-group group-id="TestTreePopupMenu" anchor="last"/>
    </group>


  </actions>
</component>
